// Base
import * as base from './_crud-base'

// Types
import type { Unit } from '~/models/unit'

const path = '/api/v1/unit'
const name = 'unit'

export function create(data: any) {
  return base.create(path, data, name)
}

export function getList(params: any = null) {
  return base.getList(path, params, name)
}

export function getDetail(id: number | string) {
  return base.getDetail(path, id, name)
}

export function update(id: number | string, data: any) {
  return base.update(path, id, data, name)
}

export function remove(id: number | string) {
  return base.remove(path, id, name)
}

export async function getValueLabelList(params: any = null, useId = false): Promise<{ value: string; label: string }[]> {
  let data: { value: string; label: string }[] = []
  const result = await getList(params)
  if (result.success) {
    const resultData = result.body?.data || []
    data = !useId ?
      resultData.map((item: Unit) => ({ value: item.code, label: item.name })) :
      resultData.map((item: Unit) => ({ value: item.id, label: item.name }))
  }
  return data
}
